 'This function only resturns text in cell if any

function XL_MYFIRST(byval xString as LPXLOPER12) as lpXLOPER12 export
 dim mystr as wstring*255
 
 mystr = "This function returns text"
 static UDT as xloper12
 if xstring->xltype = xlstring THEN
   mystr = *readpascalstrW(xstring)
   
 
   udt.xltype = xlstring  
 udt.val.str= WritepascalStrW(mystr)
 return @UDT
 END IF
 
end function
 '-----------------------------------------------------------------
 'This function sum numbers in a passed OPER range. Type P in register function
 '-----------------------------------------------------------------
 function XL_SUMRANGE(xRange as LPXLOPER) as  LPXLOPER export
  dim Errtext as zstring*250
  static UDT as XLOPER 
  dim xSumArray as lpxloper
  dim dSum as Double
  dim as long i,j,lcol, lrow 
  on error goto XL_SUMRANGEerror
  
  Errtext = "Need array as input"
  'if passed argument not an array then raise error and give feedback
  if xrange->xltype <> xlarray then  Error RaiseErr 
   'we have an array
   'get rows and columns
    lcol = xrange->val.array.columns 
    lrow = xrange->val.array.rows 
   xSumArray = xRange->val.array.lparray 'assign addresss to first element
for i = 0 to lrow -1
   for j = 0 to lcol - 1
      
    if xSumArray[i * lcol + j].xltype = xlnumeric then 'ignore non-numeric elements
        dsum  += xSumArray[i * lcol + j].val.num
         
       end if  
   NEXT
   
NEXT
udt.xltype = xlnumeric
udt.val.num = dsum
return @udt 
  exit function
  XL_SUMRANGEerror:
   udt.xltype = xlstring
   udt.val.str = writepascalstr(errtext)
   return @UDT
 END FUNCTION  
'-----------------------------------------------------------------
'Function : XL_FldsToString_Unicode
'Programmer : E. Dingsor
'Date: xx/xx/08
'This function concats string values from cells into one string
'Input: range, separator, optional  extra string qoutes
'useful for putting together dynamic  parameters for  SQL queries
'----------------------------------------------------------------- 

FUNCTION XL_FLDSTOSTRING_UNICODE(BYVAL xArea AS XLOPER12 PTR,BYVAL xSep AS XLOPER PTR,BYVAL xQuote AS XLOPER PTR) as LPXLOPER12 EXPORT 
static UDT AS  XLOPER12
DIM xTemp AS XLOPER12
dim sArr() AS  string  'wSTRING
DIM zsTemp AS WSTRING * MAX_UNICODE_EXCEL

DIM sTEmp AS STRING
DIM xCell AS XLOPER12
DIM lREt AS LONG
DIM Idsheet AS DWORD
DIM AS LONG lColFirst,lCollast,lrowFirst,lRowlast, i,j, lQuote,lSuccsess, lcount 
DIM zSep AS zsTRING*25 , zQuote AS zsTRING*25

DIM zsErrtext AS WSTRING*255
zsErrtext= "Error in input"
 zSep = "," 'default
 zQuote= ""  'default
 lQuote   = FALSE  'default

ON ERROR GOTO  XL_FldsToStringFeil

'check if xArea is a SREF
SELECT CASE xArea->xltype
  CASE xlTypeRef ,xlTypeSRef
      'get sheet id  + rows, cols in the range area
      Idsheet = GetSheetIDPluss12(BYVAL xArea,lRowFirst,lRowLast ,lColFirst,lColLast )
        
      CASE ELSE
      zsErrtext= "No range provided"
      ERROR RaiseErr

END SELECT
  IF xSEP->xltype = XLSTRING THEN
     'read passed separator
      zSep = *REadpascalStr(BYVAL xSep)
      
  END IF
  IF xQuote->xltype = XLSTRING THEN
     'read Extra coutes
      zQuote = *REadpascalStr(BYVAL xQuote)
      lQuote = TRUE
  END IF
 'now loop over the range and see if cells contain strings
     FOR i = lRowFirst TO lrowLast
         FOR j = lColFirst TO lColLast
        CreateCellRef12(xCell, idSheet, i,i,j,j, lSuccsess)
        
       IF  xlretsuccess = excel12( Xlcoerce OR xlIntl,BYVAL VARPTR(xtemp), 2 ,@xCell, BYVAL TempINt12(xltypeStr))   THEN

             IF xTemp.xltype = xlString THEN
                 stemp = str(*readpascalstrW(BYVAL VARPTR(xTemp)))
                  
                 IF LEN(stemp) > 0 THEN
                     
                     lCount +=  1    'increase counter
                    REDIM PRESERVE sArr(1 TO lcount) 
                   sArr(lcount)= stemp
                   
                   
                    stemp = ""
                END IF
              END IF
         END IF
        NEXT
     NEXT
         
     IF lCount > 0 THEN
         IF   lQuote = TRUE THEN  zSep =     zQuote & zSep & zQuote
            for i = 1 to lcount - 1 
               'join string elements in array
                stemp += sarr(i) & zSep
            
            NEXT
            'handle last array element. we don't like separator at the end, but need the extra quote if any
            stemp = zQuote & stemp & sarr(lcount) & zQuote
            zsTemp = wstr(stemp)  'convert to wide char
           
         UDT.xltype = XLSTRING
         UDT.val.str = WritepascalstrW(zsTEmp)
        FUNCTION = VARPTR(UDT)
      ELSE
          UDT.xltype = XLSTRING
            zsErrtext = "Nothing to join!"
           UDT.val.str = WritepascalstrW(zsErrtext)
         FUNCTION = VARPTR(UDT)
      END IF

EXIT FUNCTION
XL_FldsToStringFeil:
UDT.xltype = xlstring
UDT.val.str = WritepascalstrW(zsErrtext)
FUNCTION = VARPTR(UDT)

END FUNCTION 

'-----------------------------------------------------------------
'Function : XL_FASTLOOKUP
'Programmer : E. Dingsor
'Date: xx/xx/07
'This function does the same as Vlookup, but uses INDEX & MATCH functions
'User can also decide which colums to search in. Defaults to column 1
'
'-----------------------------------------------------------------
FUNCTION XL_FASTLOOKUP(BYVAL xCriteria AS LPXLOPER ,BYVAL xArea AS LPXLOPER,BYVAL xLookCol AS LPXLOPER,BYVAL xRetCol AS LPXLOPER) as LPXLOPER EXPORT
STATIC UDT AS  XLOPER
DIM As XLOPER xlLOOKcol,xMatchCol
dim lREt AS LONG
dim AS XLOPER xInterim, xINterimIndex 
dim lCol AS LONG
DIM zsErrtext AS zsTRING*255
zsErrtext= "Error in input"
lCol = 1 'default
ON ERROR GOTO  XL_FASTLOOKUPfeil
'check which column to search in for criteria value. Defaults to 1
SELECT CASE  xLookCol->xltype
        CASE xlnumeric
         xlLOOKcol = *xLookCol
          lCol = xLookCol->val.num
        CASE ELSE     'default search column
        xlLOOKcol.xltype = xlnumeric
        xlLOOKcol.val.num = 1
END SELECT
'check if xArea is a SREF

SELECT CASE xArea->xltype
  CASE xlTypeRef ,xlTypeSRef
     'create a temporary sub range for input to xlfmatch(excel's internal function that we'll call later on
     'we're going to communicate with Excel itself and use its own functions
      CreateSubXLOPERArray(BYVAL xArea ,xMatchCol , lCOl)
      
END SELECT
 'now make Excel do the first MATCH lookup
 'we're now calling into excel and have excel to do some interim matching
    
   
  lRet = excel4(xlfMatch OR xlIntl, @xInterim, 3 ,xCriteria ,@xMatchCol, tempint(0))
   
  IF lREt =  xlretsuccess THEN       'match worked
  
     lret = excel4(xlfIndex OR xlIntl, @xINterimIndex, 3 ,xArea ,@xInterim , xRetCol)
           
         UDT =   xINterimIndex
        FUNCTION = VARPTR(UDT)
  ELSE
     
     UDT = xInterim
        FUNCTION = VARPTR(UDT)
      
  END IF
  'free xlopers
  Excel4 xlFree OR Xlintl, 0, 1, BYVAL VARPTR(xInterim)
  Excel4 xlFree OR Xlintl, 0, 1, BYVAL VARPTR(xINterimIndex)
EXIT FUNCTION
XL_FASTLOOKUPfeil:
UDT.xltype = xlstring
UDT.val.str = Writepascalstr(zsErrtext)
FUNCTION = VARPTR(UDT)

END FUNCTION

const pi as double = 3.1415926535897932384626433
'**********************
'Function that calulates area of a circle
'**********************
function XL_CIRCLEAREA(xradius as lpxloper)  as lpxloper export
DIM zsErrtext AS zsTRING*255
dim dresult as double
STATIC UDT AS  XLOPER
zsErrtext= "Need a number"   
on error goto CircleAreaError
'check if number is passed

if xradius->xltype = xlnumeric then
   dresult = xradius->val.num ^2 * pi
   UDT.xltype = xlnumeric
   udt.val.num = dresult
   else 'throw an error
      ERROR RaiseErr
END IF
 return @udt
exit function
CircleAreaError:
UDT.xltype = xlstring
UDT.val.str = Writepascalstr(zsErrtext)
FUNCTION = VARPTR(UDT)  
END FUNCTION
