#pragma once
#DEFINE __FB_WIN32__

#DEFINE __FB_LANG__
#include once "crt/long.bi"

#if defined(__FB_WIN32__) or defined(__FB_CYGWIN__)
	'extern "C"
   
#endif
#inclib "libxlcall32"
TYPE DWORD AS UINT32 
TYPE LPSTR AS ZSTRING PTR 

TYPE WORD AS UINT16

TYPE BOOL as LONG   
type XCHAR as wstring 'WCHAR

type RW as INT32
type COL as INT32
type IDSHEET as DWORD 'PTR

type XLREF  
	rwFirst as WORD
	rwLast as WORD
	colFirst as BYTE
	colLast as BYTE
end type

type LPXLREF as XLREF ptr

type XLMREF  
	count as WORD
	reftbl(0 to 0) as XLREF
end type

type LPXLMREF as XLMREF ptr

type XLREF12 
	rwFirst as RW
	rwLast as RW
	colFirst as COL
	colLast as COL
end type

type LPXLREF12 as XLREF12 ptr

type XLMREF12 
	count as WORD
	reftbl(0 to 0) as XLREF12
end type

type LPXLMREF12 as XLMREF12 ptr

type _FP
	rows as ushort
	columns as ushort
	array(0 to 0) as DOUBLE
end type

type FP as _FP

type _FP12  
	rows as INT32
	columns as INT32
	array(0 to 0) as double
end type

type FP12 as _FP12

type xloper_val_sref 
	count as WORD
	ref as XLREF
end type

type xloper_val_mref 
	lpmref as XLMREF ptr
	idSheet as IDSHEET
end type

type XLOPER as XLOPER_

type xloper_val_array  
	lparray as XLOPER ptr
	rows as WORD
	columns as WORD
end type

union xloper_val_flow_valflow  
	level as short
	tbctrl as short
	idSheet as IDSHEET
end union

type xloper_val_flow 
	valflow as xloper_val_flow_valflow
	rw as WORD
	col as BYTE
	xlflow as BYTE
end type

union xloper_val_bigdata_h
	lpbData as BYTE ptr
	hdata as HANDLE
end union

type xloper_val_bigdata  
	h as xloper_val_bigdata_h
	cbData as clong
end type

union xloper_val 
	num as double
	str as zstring ptr 'LPSTR
	bool as WORD
	err as WORD
	w as short
	sref as xloper_val_sref
	mref as xloper_val_mref
	array as xloper_val_array
	flow as xloper_val_flow
	bigdata as xloper_val_bigdata
end union

type XLOPER_  
	val as xloper_val
	xltype as WORD
end type

type LPXLOPER as XLOPER ptr

type xloper12_val_sref 
	count as WORD
	ref as XLREF12
end type

type xloper12_val_mref 
	lpmref as XLMREF12 ptr
	idSheet as IDSHEET
end type

type XLOPER12 as XLOPER12_

type xloper12_val_array 
	lparray as XLOPER12 ptr
	rows as RW
	columns as COL
end type

union xloper12_val_flow_valflow 
	level as long
	tbctrl as long
	idSheet as IDSHEET
end union

type xloper12_val_flow  
	valflow as xloper12_val_flow_valflow
	rw as RW
	col as COL
	xlflow as BYTE
end type

union xloper12_val_bigdata_h
	lpbData as BYTE ptr
	hdata as HANDLE
end union

type xloper12_val_bigdata   
	h as xloper12_val_bigdata_h
	cbData as clong
end type

union xloper12_val  
	num as double
	str as wstring ptr 'XCHAR ptr
	xbool as BOOL
	err as long
	w as long
	sref as xloper12_val_sref
	mref as xloper12_val_mref
	array as xloper12_val_array
	flow as xloper12_val_flow
	bigdata as xloper12_val_bigdata
end union

type XLOPER12_ 
	val as xloper12_val
	xltype as DWORD
end type

type LPXLOPER12 as XLOPER12 PTR
'xltypes  field definitions
'Constants for xlType when constructing XLOPER structs
Const xlNumeric        = &H1   'Arg is numeric   1
Const xlString         = &H2     'Arg is String    2
Const xlBoolean        = &H4    'Arg is Logical   4
Const xlError          = 16 '&H10    'arg is error     16
Const xlArray          = &H40   'arg is array     64
Const xlMissing_Arg    = &H80   'arg is missing   128
Const xlEmpty_Cell     = &H100  'Empty cell       256

' Constanst for sub Types of XlError
Const XlErrNull     = 0 '#Null!
Const XlErrDiv0     = 7 '#Div0!
Const XlErrValue    = 15 '#Value!
Const XlErrRef      = 23 '#Ref!
Const XlErrName     = 29 '#Name!
Const XlErrNum      = 36 '#Name!
Const XlErrNA       = 42 '#N/A!

'//Constants for XlBoolean
Const XlBoolTrue    = &H1 '1 'true
Const XlBoolFalse   = &H0 '0 'false

'memory address offset constant for array elements beyond first element
Const MemOff = &H10 'Hexamal representation of the number 16
Const MemOff12 = &H20 'Hexamal representation of the number 32
'Option base constants for arrays
Const OptionBase0 = 0
Const OptionBase1 = 1

'error code/number to raise an error to show info trough function
Const RaiseErr = &H6A ' number 106
'constant for Array offset to make sure that first arr el is on a 16 bit boundry
Const ArrOne = 1
'Const ArrOne = 0

'Equate Constants
Const ExcelCorr = -1  'for correction when calulating dates. MS thought year 1900 was a leap year and it was not!

const xltypeNum = &h0001
const xltypeStr = &h0002
const xltypeBool = &h0004
const xltypeRef = &h0008
const xltypeErr = &h0010
const xltypeFlow = &h0020
const xltypeMulti = &h0040
const xltypeMissing = &h0080
const xltypeNil = &h0100
const xltypeSRef = &h0400
const xltypeInt = &h0800
const xlbitXLFree = &h1000
const xlbitDLLFree = &h4000
const xltypeBigData = xltypeStr or xltypeInt
const xlerrNull = 0
const xlerrDiv0 = 7
const xlerrValue = 15
const xlerrRef = 23
const xlerrName = 29
const xlerrNum = 36
const xlerrNA = 42
const xlerrGettingData = 43
const xlflowHalt = 1
const xlflowGoto = 2
const xlflowRestart = 8
const xlflowPause = 16
const xlflowResume = 64
const xlretSuccess = 0
const xlretAbort = 1
const xlretInvXlfn = 2
const xlretInvCount = 4
const xlretInvXloper = 8
const xlretStackOvfl = 16
const xlretFailed = 32
const xlretUncalced = 64
const xlretNotThreadSafe = 128
const xlretInvAsynchronousContext = 256
const xlretNotClusterSafe = 512
const xleventCalculationEnded = 1
const xleventCalculationCanceled = 2



'*****************
extern "C"
DECLARE FUNCTION Excel4 Cdecl  ALIAS "Excel4"(byval xlfn as long,byval  operRes as LPXLOPER , byval count as long,... ) as LONG


DECLARE FUNCTION Excel12 CDECL ALIAS "Excel12"(byval xlfn as long, byval operRes as LPXLOPER12, byval count as long,...) as long
END extern
'' TODO: int pascal Excel4v(int xlfn, LPXLOPER operRes, int count, LPXLOPER opers[]);



extern "Windows"

DECLARE FUNCTION EXCEL4V PASCAL  ALIAS "Excel4v" (ByVal xlfn As Long , byval operRes as LPXLOPER, BYVAL count  AS long,BYVAL opers AS  LPXLOPER ) AS LONG 
DECLARE FUNCTION XLCallVer PASCAL  ALIAS "XLCallVer"() AS LONG
'' TODO: long pascal LPenHelper(int wCode, VOID *lpv) as long
DECLARE FUNCTION LPenHelper PASCAL   ALIAS "LPenHelper" (BYVAL wcode AS LONG, BYREF lpv AS ANY) AS LONG
end extern

 
'DECLARE FUNCTION EXCEL12V  PASCAL    ALIAS "Excel12v" (BYVAL  xlfn AS LONG, BYVAL operRes AS LPXLOPER12 , BYVAL count AS LONG,  opers() AS LPXLOPER12 ) AS LONG



'' TODO: typedef int (CALLBACK *PXL_HPC_ASYNC_CALLBACK)(LPXLOPER12 operAsyncHandle, LPXLOPER12 operReturn);
const xlHpcRetSuccess = 0
const xlHpcRetSessionIdInvalid = -1
const xlHpcRetCallFailed = -2
const xlCommand = &h8000
const xlSpecial = &h4000
const xlIntl = &h2000
const xlPrompt = &h1000
const xlFree = 0 or xlSpecial
const xlStack = 1 or xlSpecial
const xlCoerce = 2 or xlSpecial
const xlSet = 3 or xlSpecial
const xlSheetId = 4 or xlSpecial
const xlSheetNm = 5 or xlSpecial
const xlAbort = 6 or xlSpecial
const xlGetInst = 7 or xlSpecial
const xlGetHwnd = 8 or xlSpecial
const xlGetName = 9 or xlSpecial
const xlEnableXLMsgs = 10 or xlSpecial
const xlDisableXLMsgs = 11 or xlSpecial
const xlDefineBinaryName = 12 or xlSpecial
const xlGetBinaryName = 13 or xlSpecial
const xlGetFmlaInfo = 14 or xlSpecial
const xlGetMouseInfo = 15 or xlSpecial
const xlAsyncReturn = 16 or xlSpecial
const xlEventRegister = 17 or xlSpecial
const xlRunningOnCluster = 18 or xlSpecial
const xlGetInstPtr = 19 or xlSpecial
const xlModeReady = 0
const xlModeEnter = 1
const xlModeEdit = 2
const xlModePoint = 4
const dtNil = &h7f
const dtSheet = 0
const dtProc = 1
const dtChart = 2
const dtBasic = 6
const htNone = &h00
const htClient = &h01
const htVSplit = &h02
const htHSplit = &h03
const htColWidth = &h04
const htRwHeight = &h05
const htRwColHdr = &h06
const htObject1 = &h07
const htTopLeft1 = &h08
const htBotLeft = &h09
const htLeft = &h0A
const htTopRight1 = &h0B
const htBotRight = &h0C
const htRight1 = &h0D
const htTop1 = &h0E
const htBot = &h0F
const htRwGut = &h10
const htColGut = &h11
const htTextBox = &h12
const htRwLevels = &h13
const htColLevels = &h14
const htDman = &h15
const htDmanFill = &h16
const htXSplit = &h17
const htVertex = &h18
const htAddVtx = &h19
const htDelVtx = &h1A
const htRwHdr = &h1B
const htColHdr = &h1C
const htRwShow = &h1D
const htColShow = &h1E
const htSizing = &h1F
const htSxpivot = &h20
const htTabs = &h21
const htEdit = &h22

type _fmlainfo
	wPointMode as long
	cch as long
	lpch as zstring ptr
	ichFirst as long
	ichLast as long
	ichCaret as long
end type

type FMLAINFO as _fmlainfo

type _mouseinfo
	hwnd as HWND
	pt as POINT
	dt as long
	ht as long
	rw as long
	col as long
end type

type MOUSEINFO as _mouseinfo
const xlUDF = 255
const xlfCount = 0
const xlfIsna = 2
const xlfIserror = 3
const xlfSum = 4
const xlfAverage = 5
const xlfMin = 6
const xlfMax = 7
const xlfRow = 8
const xlfColumn = 9
const xlfNa = 10
const xlfNpv = 11
const xlfStdev = 12
const xlfDollar = 13
const xlfFixed = 14
const xlfSin = 15
const xlfCos = 16
const xlfTan = 17
const xlfAtan = 18
const xlfPi = 19
const xlfSqrt = 20
const xlfExp = 21
const xlfLn = 22
const xlfLog10 = 23
const xlfAbs = 24
const xlfInt = 25
const xlfSign = 26
const xlfRound = 27
const xlfLookup = 28
const xlfIndex = 29
const xlfRept = 30
const xlfMid = 31
const xlfLen = 32
const xlfValue = 33
const xlfTrue = 34
const xlfFalse = 35
const xlfAnd = 36
const xlfOr = 37
const xlfNot = 38
const xlfMod = 39
const xlfDcount = 40
const xlfDsum = 41
const xlfDaverage = 42
const xlfDmin = 43
const xlfDmax = 44
const xlfDstdev = 45
const xlfVar = 46
const xlfDvar = 47
const xlfText = 48
const xlfLinest = 49
const xlfTrend = 50
const xlfLogest = 51
const xlfGrowth = 52
const xlfGoto = 53
const xlfHalt = 54
const xlfPv = 56
const xlfFv = 57
const xlfNper = 58
const xlfPmt = 59
const xlfRate = 60
const xlfMirr = 61
const xlfIrr = 62
const xlfRand = 63
const xlfMatch = 64
const xlfDate = 65
const xlfTime = 66
const xlfDay = 67
const xlfMonth = 68
const xlfYear = 69
const xlfWeekday = 70
const xlfHour = 71
const xlfMinute = 72
const xlfSecond = 73
const xlfNow = 74
const xlfAreas = 75
const xlfRows = 76
const xlfColumns = 77
const xlfOffset = 78
const xlfAbsref = 79
const xlfRelref = 80
const xlfArgument = 81
const xlfSearch = 82
const xlfTranspose = 83
const xlfError = 84
const xlfStep = 85
const xlfType = 86
const xlfEcho = 87
const xlfSetName = 88
const xlfCaller = 89
const xlfDeref = 90
const xlfWindows = 91
const xlfSeries = 92
const xlfDocuments = 93
const xlfActiveCell = 94
const xlfSelection = 95
const xlfResult = 96
const xlfAtan2 = 97
const xlfAsin = 98
const xlfAcos = 99
const xlfChoose = 100
const xlfHlookup = 101
const xlfVlookup = 102
const xlfLinks = 103
const xlfInput = 104
const xlfIsref = 105
const xlfGetFormula = 106
const xlfGetName = 107
const xlfSetValue = 108
const xlfLog = 109
const xlfExec = 110
const xlfChar = 111
const xlfLower = 112
const xlfUpper = 113
const xlfProper = 114
const xlfLeft = 115
const xlfRight = 116
const xlfExact = 117
const xlfTrim = 118
const xlfReplace = 119
const xlfSubstitute = 120
const xlfCode = 121
const xlfNames = 122
const xlfDirectory = 123
const xlfFind = 124
const xlfCell = 125
const xlfIserr = 126
const xlfIstext = 127
const xlfIsnumber = 128
const xlfIsblank = 129
const xlfT = 130
const xlfN = 131
const xlfFopen = 132
const xlfFclose = 133
const xlfFsize = 134
const xlfFreadln = 135
const xlfFread = 136
const xlfFwriteln = 137
const xlfFwrite = 138
const xlfFpos = 139
const xlfDatevalue = 140
const xlfTimevalue = 141
const xlfSln = 142
const xlfSyd = 143
const xlfDdb = 144
const xlfGetDef = 145
const xlfReftext = 146
const xlfTextref = 147
const xlfIndirect = 148
const xlfRegister = 149
const xlfCall = 150
const xlfAddBar = 151
const xlfAddMenu = 152
const xlfAddCommand = 153
const xlfEnableCommand = 154
const xlfCheckCommand = 155
const xlfRenameCommand = 156
const xlfShowBar = 157
const xlfDeleteMenu = 158
const xlfDeleteCommand = 159
const xlfGetChartItem = 160
const xlfDialogBox = 161
const xlfClean = 162
const xlfMdeterm = 163
const xlfMinverse = 164
const xlfMmult = 165
const xlfFiles = 166
const xlfIpmt = 167
const xlfPpmt = 168
const xlfCounta = 169
const xlfCancelKey = 170
const xlfInitiate = 175
const xlfRequest = 176
const xlfPoke = 177
const xlfExecute = 178
const xlfTerminate = 179
const xlfRestart = 180
const xlfHelp = 181
const xlfGetBar = 182
const xlfProduct = 183
const xlfFact = 184
const xlfGetCell = 185
const xlfGetWorkspace = 186
const xlfGetWindow = 187
const xlfGetDocument = 188
const xlfDproduct = 189
const xlfIsnontext = 190
const xlfGetNote = 191
const xlfNote = 192
const xlfStdevp = 193
const xlfVarp = 194
const xlfDstdevp = 195
const xlfDvarp = 196
const xlfTrunc = 197
const xlfIslogical = 198
const xlfDcounta = 199
const xlfDeleteBar = 200
const xlfUnregister = 201
const xlfUsdollar = 204
const xlfFindb = 205
const xlfSearchb = 206
const xlfReplaceb = 207
const xlfLeftb = 208
const xlfRightb = 209
const xlfMidb = 210
const xlfLenb = 211
const xlfRoundup = 212
const xlfRounddown = 213
const xlfAsc = 214
const xlfDbcs = 215
const xlfRank = 216
const xlfAddress = 219
const xlfDays360 = 220
const xlfToday = 221
const xlfVdb = 222
const xlfMedian = 227
const xlfSumproduct = 228
const xlfSinh = 229
const xlfCosh = 230
const xlfTanh = 231
const xlfAsinh = 232
const xlfAcosh = 233
const xlfAtanh = 234
const xlfDget = 235
const xlfCreateObject = 236
const xlfVolatile = 237
const xlfLastError = 238
const xlfCustomUndo = 239
const xlfCustomRepeat = 240
const xlfFormulaConvert = 241
const xlfGetLinkInfo = 242
const xlfTextBox = 243
const xlfInfo = 244
const xlfGroup = 245
const xlfGetObject = 246
const xlfDb = 247
const xlfPause = 248
const xlfResume = 251
const xlfFrequency = 252
const xlfAddToolbar = 253
const xlfDeleteToolbar = 254
const xlfResetToolbar = 256
const xlfEvaluate = 257
const xlfGetToolbar = 258
const xlfGetTool = 259
const xlfSpellingCheck = 260
const xlfErrorType = 261
const xlfAppTitle = 262
const xlfWindowTitle = 263
const xlfSaveToolbar = 264
const xlfEnableTool = 265
const xlfPressTool = 266
const xlfRegisterId = 267
const xlfGetWorkbook = 268
const xlfAvedev = 269
const xlfBetadist = 270
const xlfGammaln = 271
const xlfBetainv = 272
const xlfBinomdist = 273
const xlfChidist = 274
const xlfChiinv = 275
const xlfCombin = 276
const xlfConfidence = 277
const xlfCritbinom = 278
const xlfEven = 279
const xlfExpondist = 280
const xlfFdist = 281
const xlfFinv = 282
const xlfFisher = 283
const xlfFisherinv = 284
const xlfFloor = 285
const xlfGammadist = 286
const xlfGammainv = 287
const xlfCeiling = 288
const xlfHypgeomdist = 289
const xlfLognormdist = 290
const xlfLoginv = 291
const xlfNegbinomdist = 292
const xlfNormdist = 293
const xlfNormsdist = 294
const xlfNorminv = 295
const xlfNormsinv = 296
const xlfStandardize = 297
const xlfOdd = 298
const xlfPermut = 299
const xlfPoisson = 300
const xlfTdist = 301
const xlfWeibull = 302
const xlfSumxmy2 = 303
const xlfSumx2my2 = 304
const xlfSumx2py2 = 305
const xlfChitest = 306
const xlfCorrel = 307
const xlfCovar = 308
const xlfForecast = 309
const xlfFtest = 310
const xlfIntercept = 311
const xlfPearson = 312
const xlfRsq = 313
const xlfSteyx = 314
const xlfSlope = 315
const xlfTtest = 316
const xlfProb = 317
const xlfDevsq = 318
const xlfGeomean = 319
const xlfHarmean = 320
const xlfSumsq = 321
const xlfKurt = 322
const xlfSkew = 323
const xlfZtest = 324
const xlfLarge = 325
const xlfSmall = 326
const xlfQuartile = 327
const xlfPercentile = 328
const xlfPercentrank = 329
const xlfMode = 330
const xlfTrimmean = 331
const xlfTinv = 332
const xlfMovieCommand = 334
const xlfGetMovie = 335
const xlfConcatenate = 336
const xlfPower = 337
const xlfPivotAddData = 338
const xlfGetPivotTable = 339
const xlfGetPivotField = 340
const xlfGetPivotItem = 341
const xlfRadians = 342
const xlfDegrees = 343
const xlfSubtotal = 344
const xlfSumif = 345
const xlfCountif = 346
const xlfCountblank = 347
const xlfScenarioGet = 348
const xlfOptionsListsGet = 349
const xlfIspmt = 350
const xlfDatedif = 351
const xlfDatestring = 352
const xlfNumberstring = 353
const xlfRoman = 354
const xlfOpenDialog = 355
const xlfSaveDialog = 356
const xlfViewGet = 357
const xlfGetpivotdata = 358
const xlfHyperlink = 359
const xlfPhonetic = 360
const xlfAveragea = 361
const xlfMaxa = 362
const xlfMina = 363
const xlfStdevpa = 364
const xlfVarpa = 365
const xlfStdeva = 366
const xlfVara = 367
const xlfBahttext = 368
const xlfThaidayofweek = 369
const xlfThaidigit = 370
const xlfThaimonthofyear = 371
const xlfThainumsound = 372
const xlfThainumstring = 373
const xlfThaistringlength = 374
const xlfIsthaidigit = 375
const xlfRoundbahtdown = 376
const xlfRoundbahtup = 377
const xlfThaiyear = 378
const xlfRtd = 379
const xlfCubevalue = 380
const xlfCubemember = 381
const xlfCubememberproperty = 382
const xlfCuberankedmember = 383
const xlfHex2bin = 384
const xlfHex2dec = 385
const xlfHex2oct = 386
const xlfDec2bin = 387
const xlfDec2hex = 388
const xlfDec2oct = 389
const xlfOct2bin = 390
const xlfOct2hex = 391
const xlfOct2dec = 392
const xlfBin2dec = 393
const xlfBin2oct = 394
const xlfBin2hex = 395
const xlfImsub = 396
const xlfImdiv = 397
const xlfImpower = 398
const xlfImabs = 399
const xlfImsqrt = 400
const xlfImln = 401
const xlfImlog2 = 402
const xlfImlog10 = 403
const xlfImsin = 404
const xlfImcos = 405
const xlfImexp = 406
const xlfImargument = 407
const xlfImconjugate = 408
const xlfImaginary = 409
const xlfImreal = 410
const xlfComplex = 411
const xlfImsum = 412
const xlfImproduct = 413
const xlfSeriessum = 414
const xlfFactdouble = 415
const xlfSqrtpi = 416
const xlfQuotient = 417
const xlfDelta = 418
const xlfGestep = 419
const xlfIseven = 420
const xlfIsodd = 421
const xlfMround = 422
const xlfErf = 423
const xlfErfc = 424
const xlfBesselj = 425
const xlfBesselk = 426
const xlfBessely = 427
const xlfBesseli = 428
const xlfXirr = 429
const xlfXnpv = 430
const xlfPricemat = 431
const xlfYieldmat = 432
const xlfIntrate = 433
const xlfReceived = 434
const xlfDisc = 435
const xlfPricedisc = 436
const xlfYielddisc = 437
const xlfTbilleq = 438
const xlfTbillprice = 439
const xlfTbillyield = 440
const xlfPrice = 441
const xlfYield = 442
const xlfDollarde = 443
const xlfDollarfr = 444
const xlfNominal = 445
const xlfEffect = 446
const xlfCumprinc = 447
const xlfCumipmt = 448
const xlfEdate = 449
const xlfEomonth = 450
const xlfYearfrac = 451
const xlfCoupdaybs = 452
const xlfCoupdays = 453
const xlfCoupdaysnc = 454
const xlfCoupncd = 455
const xlfCoupnum = 456
const xlfCouppcd = 457
const xlfDuration = 458
const xlfMduration = 459
const xlfOddlprice = 460
const xlfOddlyield = 461
const xlfOddfprice = 462
const xlfOddfyield = 463
const xlfRandbetween = 464
const xlfWeeknum = 465
const xlfAmordegrc = 466
const xlfAmorlinc = 467
const xlfConvert = 468
const xlfAccrint = 469
const xlfAccrintm = 470
const xlfWorkday = 471
const xlfNetworkdays = 472
const xlfGcd = 473
const xlfMultinomial = 474
const xlfLcm = 475
const xlfFvschedule = 476
const xlfCubekpimember = 477
const xlfCubeset = 478
const xlfCubesetcount = 479
const xlfIferror = 480
const xlfCountifs = 481
const xlfSumifs = 482
const xlfAverageif = 483
const xlfAverageifs = 484
const xlfAggregate = 485
const xlfBinom_dist = 486
const xlfBinom_inv = 487
const xlfConfidence_norm = 488
const xlfConfidence_t = 489
const xlfChisq_test = 490
const xlfF_test = 491
const xlfCovariance_p = 492
const xlfCovariance_s = 493
const xlfExpon_dist = 494
const xlfGamma_dist = 495
const xlfGamma_inv = 496
const xlfMode_mult = 497
const xlfMode_sngl = 498
const xlfNorm_dist = 499
const xlfNorm_inv = 500
const xlfPercentile_exc = 501
const xlfPercentile_inc = 502
const xlfPercentrank_exc = 503
const xlfPercentrank_inc = 504
const xlfPoisson_dist = 505
const xlfQuartile_exc = 506
const xlfQuartile_inc = 507
const xlfRank_avg = 508
const xlfRank_eq = 509
const xlfStdev_s = 510
const xlfStdev_p = 511
const xlfT_dist = 512
const xlfT_dist_2t = 513
const xlfT_dist_rt = 514
const xlfT_inv = 515
const xlfT_inv_2t = 516
const xlfVar_s = 517
const xlfVar_p = 518
const xlfWeibull_dist = 519
const xlfNetworkdays_intl = 520
const xlfWorkday_intl = 521
const xlfEcma_ceiling = 522
const xlfIso_ceiling = 523
const xlfBeta_dist = 525
const xlfBeta_inv = 526
const xlfChisq_dist = 527
const xlfChisq_dist_rt = 528
const xlfChisq_inv = 529
const xlfChisq_inv_rt = 530
const xlfF_dist = 531
const xlfF_dist_rt = 532
const xlfF_inv = 533
const xlfF_inv_rt = 534
const xlfHypgeom_dist = 535
const xlfLognorm_dist = 536
const xlfLognorm_inv = 537
const xlfNegbinom_dist = 538
const xlfNorm_s_dist = 539
const xlfNorm_s_inv = 540
const xlfT_test = 541
const xlfZ_test = 542
const xlfErf_precise = 543
const xlfErfc_precise = 544
const xlfGammaln_precise = 545
const xlfCeiling_precise = 546
const xlfFloor_precise = 547
const xlcBeep = 0 or xlCommand
const xlcOpen = 1 or xlCommand
const xlcOpenLinks = 2 or xlCommand
const xlcCloseAll = 3 or xlCommand
const xlcSave = 4 or xlCommand
const xlcSaveAs = 5 or xlCommand
const xlcFileDelete = 6 or xlCommand
const xlcPageSetup = 7 or xlCommand
const xlcPrint = 8 or xlCommand
const xlcPrinterSetup = 9 or xlCommand
const xlcQuit = 10 or xlCommand
const xlcNewWindow = 11 or xlCommand
const xlcArrangeAll = 12 or xlCommand
const xlcWindowSize = 13 or xlCommand
const xlcWindowMove = 14 or xlCommand
const xlcFull = 15 or xlCommand
const xlcClose = 16 or xlCommand
const xlcRun = 17 or xlCommand
const xlcSetPrintArea = 22 or xlCommand
const xlcSetPrintTitles = 23 or xlCommand
const xlcSetPageBreak = 24 or xlCommand
const xlcRemovePageBreak = 25 or xlCommand
const xlcFont = 26 or xlCommand
const xlcDisplay = 27 or xlCommand
const xlcProtectDocument = 28 or xlCommand
const xlcPrecision = 29 or xlCommand
const xlcA1R1c1 = 30 or xlCommand
const xlcCalculateNow = 31 or xlCommand
const xlcCalculation = 32 or xlCommand
const xlcDataFind = 34 or xlCommand
const xlcExtract = 35 or xlCommand
const xlcDataDelete = 36 or xlCommand
const xlcSetDatabase = 37 or xlCommand
const xlcSetCriteria = 38 or xlCommand
const xlcSort = 39 or xlCommand
const xlcDataSeries = 40 or xlCommand
const xlcTable = 41 or xlCommand
const xlcFormatNumber = 42 or xlCommand
const xlcAlignment = 43 or xlCommand
const xlcStyle = 44 or xlCommand
const xlcBorder = 45 or xlCommand
const xlcCellProtection = 46 or xlCommand
const xlcColumnWidth = 47 or xlCommand
const xlcUndo = 48 or xlCommand
const xlcCut = 49 or xlCommand
const xlcCopy = 50 or xlCommand
const xlcPaste = 51 or xlCommand
const xlcClear = 52 or xlCommand
const xlcPasteSpecial = 53 or xlCommand
const xlcEditDelete = 54 or xlCommand
const xlcInsert = 55 or xlCommand
const xlcFillRight = 56 or xlCommand
const xlcFillDown = 57 or xlCommand
const xlcDefineName = 61 or xlCommand
const xlcCreateNames = 62 or xlCommand
const xlcFormulaGoto = 63 or xlCommand
const xlcFormulaFind = 64 or xlCommand
const xlcSelectLastCell = 65 or xlCommand
const xlcShowActiveCell = 66 or xlCommand
const xlcGalleryArea = 67 or xlCommand
const xlcGalleryBar = 68 or xlCommand
const xlcGalleryColumn = 69 or xlCommand
const xlcGalleryLine = 70 or xlCommand
const xlcGalleryPie = 71 or xlCommand
const xlcGalleryScatter = 72 or xlCommand
const xlcCombination = 73 or xlCommand
const xlcPreferred = 74 or xlCommand
const xlcAddOverlay = 75 or xlCommand
const xlcGridlines = 76 or xlCommand
const xlcSetPreferred = 77 or xlCommand
const xlcAxes = 78 or xlCommand
const xlcLegend = 79 or xlCommand
const xlcAttachText = 80 or xlCommand
const xlcAddArrow = 81 or xlCommand
const xlcSelectChart = 82 or xlCommand
const xlcSelectPlotArea = 83 or xlCommand
const xlcPatterns = 84 or xlCommand
const xlcMainChart = 85 or xlCommand
const xlcOverlay = 86 or xlCommand
const xlcScale = 87 or xlCommand
const xlcFormatLegend = 88 or xlCommand
const xlcFormatText = 89 or xlCommand
const xlcEditRepeat = 90 or xlCommand
const xlcParse = 91 or xlCommand
const xlcJustify = 92 or xlCommand
const xlcHide = 93 or xlCommand
const xlcUnhide = 94 or xlCommand
const xlcWorkspace = 95 or xlCommand
const xlcFormula = 96 or xlCommand
const xlcFormulaFill = 97 or xlCommand
const xlcFormulaArray = 98 or xlCommand
const xlcDataFindNext = 99 or xlCommand
const xlcDataFindPrev = 100 or xlCommand
const xlcFormulaFindNext = 101 or xlCommand
const xlcFormulaFindPrev = 102 or xlCommand
const xlcActivate = 103 or xlCommand
const xlcActivateNext = 104 or xlCommand
const xlcActivatePrev = 105 or xlCommand
const xlcUnlockedNext = 106 or xlCommand
const xlcUnlockedPrev = 107 or xlCommand
const xlcCopyPicture = 108 or xlCommand
const xlcSelect = 109 or xlCommand
const xlcDeleteName = 110 or xlCommand
const xlcDeleteFormat = 111 or xlCommand
const xlcVline = 112 or xlCommand
const xlcHline = 113 or xlCommand
const xlcVpage = 114 or xlCommand
const xlcHpage = 115 or xlCommand
const xlcVscroll = 116 or xlCommand
const xlcHscroll = 117 or xlCommand
const xlcAlert = 118 or xlCommand
const xlcNew = 119 or xlCommand
const xlcCancelCopy = 120 or xlCommand
const xlcShowClipboard = 121 or xlCommand
const xlcMessage = 122 or xlCommand
const xlcPasteLink = 124 or xlCommand
const xlcAppActivate = 125 or xlCommand
const xlcDeleteArrow = 126 or xlCommand
const xlcRowHeight = 127 or xlCommand
const xlcFormatMove = 128 or xlCommand
const xlcFormatSize = 129 or xlCommand
const xlcFormulaReplace = 130 or xlCommand
const xlcSendKeys = 131 or xlCommand
const xlcSelectSpecial = 132 or xlCommand
const xlcApplyNames = 133 or xlCommand
const xlcReplaceFont = 134 or xlCommand
const xlcFreezePanes = 135 or xlCommand
const xlcShowInfo = 136 or xlCommand
const xlcSplit = 137 or xlCommand
const xlcOnWindow = 138 or xlCommand
const xlcOnData = 139 or xlCommand
const xlcDisableInput = 140 or xlCommand
const xlcEcho = 141 or xlCommand
const xlcOutline = 142 or xlCommand
const xlcListNames = 143 or xlCommand
const xlcFileClose = 144 or xlCommand
const xlcSaveWorkbook = 145 or xlCommand
const xlcDataForm = 146 or xlCommand
const xlcCopyChart = 147 or xlCommand
const xlcOnTime = 148 or xlCommand
const xlcWait = 149 or xlCommand
const xlcFormatFont = 150 or xlCommand
const xlcFillUp = 151 or xlCommand
const xlcFillLeft = 152 or xlCommand
const xlcDeleteOverlay = 153 or xlCommand
const xlcNote = 154 or xlCommand
const xlcShortMenus = 155 or xlCommand
const xlcSetUpdateStatus = 159 or xlCommand
const xlcColorPalette = 161 or xlCommand
const xlcDeleteStyle = 162 or xlCommand
const xlcWindowRestore = 163 or xlCommand
const xlcWindowMaximize = 164 or xlCommand
const xlcError = 165 or xlCommand
const xlcChangeLink = 166 or xlCommand
const xlcCalculateDocument = 167 or xlCommand
const xlcOnKey = 168 or xlCommand
const xlcAppRestore = 169 or xlCommand
const xlcAppMove = 170 or xlCommand
const xlcAppSize = 171 or xlCommand
const xlcAppMinimize = 172 or xlCommand
const xlcAppMaximize = 173 or xlCommand
const xlcBringToFront = 174 or xlCommand
const xlcSendToBack = 175 or xlCommand
const xlcMainChartType = 185 or xlCommand
const xlcOverlayChartType = 186 or xlCommand
const xlcSelectEnd = 187 or xlCommand
const xlcOpenMail = 188 or xlCommand
const xlcSendMail = 189 or xlCommand
const xlcStandardFont = 190 or xlCommand
const xlcConsolidate = 191 or xlCommand
const xlcSortSpecial = 192 or xlCommand
const xlcGallery3dArea = 193 or xlCommand
const xlcGallery3dColumn = 194 or xlCommand
const xlcGallery3dLine = 195 or xlCommand
const xlcGallery3dPie = 196 or xlCommand
const xlcView3d = 197 or xlCommand
const xlcGoalSeek = 198 or xlCommand
const xlcWorkgroup = 199 or xlCommand
const xlcFillGroup = 200 or xlCommand
const xlcUpdateLink = 201 or xlCommand
const xlcPromote = 202 or xlCommand
const xlcDemote = 203 or xlCommand
const xlcShowDetail = 204 or xlCommand
const xlcUngroup = 206 or xlCommand
const xlcObjectProperties = 207 or xlCommand
const xlcSaveNewObject = 208 or xlCommand
const xlcShare = 209 or xlCommand
const xlcShareName = 210 or xlCommand
const xlcDuplicate = 211 or xlCommand
const xlcApplyStyle = 212 or xlCommand
const xlcAssignToObject = 213 or xlCommand
const xlcObjectProtection = 214 or xlCommand
const xlcHideObject = 215 or xlCommand
const xlcSetExtract = 216 or xlCommand
const xlcCreatePublisher = 217 or xlCommand
const xlcSubscribeTo = 218 or xlCommand
const xlcAttributes = 219 or xlCommand
const xlcShowToolbar = 220 or xlCommand
const xlcPrintPreview = 222 or xlCommand
const xlcEditColor = 223 or xlCommand
const xlcShowLevels = 224 or xlCommand
const xlcFormatMain = 225 or xlCommand
const xlcFormatOverlay = 226 or xlCommand
const xlcOnRecalc = 227 or xlCommand
const xlcEditSeries = 228 or xlCommand
const xlcDefineStyle = 229 or xlCommand
const xlcLinePrint = 240 or xlCommand
const xlcEnterData = 243 or xlCommand
const xlcGalleryRadar = 249 or xlCommand
const xlcMergeStyles = 250 or xlCommand
const xlcEditionOptions = 251 or xlCommand
const xlcPastePicture = 252 or xlCommand
const xlcPastePictureLink = 253 or xlCommand
const xlcSpelling = 254 or xlCommand
const xlcZoom = 256 or xlCommand
const xlcResume = 258 or xlCommand
const xlcInsertObject = 259 or xlCommand
const xlcWindowMinimize = 260 or xlCommand
const xlcSize = 261 or xlCommand
const xlcMove = 262 or xlCommand
const xlcSoundNote = 265 or xlCommand
const xlcSoundPlay = 266 or xlCommand
const xlcFormatShape = 267 or xlCommand
const xlcExtendPolygon = 268 or xlCommand
const xlcFormatAuto = 269 or xlCommand
const xlcGallery3dBar = 272 or xlCommand
const xlcGallery3dSurface = 273 or xlCommand
const xlcFillAuto = 274 or xlCommand
const xlcCustomizeToolbar = 276 or xlCommand
const xlcAddTool = 277 or xlCommand
const xlcEditObject = 278 or xlCommand
const xlcOnDoubleclick = 279 or xlCommand
const xlcOnEntry = 280 or xlCommand
const xlcWorkbookAdd = 281 or xlCommand
const xlcWorkbookMove = 282 or xlCommand
const xlcWorkbookCopy = 283 or xlCommand
const xlcWorkbookOptions = 284 or xlCommand
const xlcSaveWorkspace = 285 or xlCommand
const xlcChartWizard = 288 or xlCommand
const xlcDeleteTool = 289 or xlCommand
const xlcMoveTool = 290 or xlCommand
const xlcWorkbookSelect = 291 or xlCommand
const xlcWorkbookActivate = 292 or xlCommand
const xlcAssignToTool = 293 or xlCommand
const xlcCopyTool = 295 or xlCommand
const xlcResetTool = 296 or xlCommand
const xlcConstrainNumeric = 297 or xlCommand
const xlcPasteTool = 298 or xlCommand
const xlcPlacement = 300 or xlCommand
const xlcFillWorkgroup = 301 or xlCommand
const xlcWorkbookNew = 302 or xlCommand
const xlcScenarioCells = 305 or xlCommand
const xlcScenarioDelete = 306 or xlCommand
const xlcScenarioAdd = 307 or xlCommand
const xlcScenarioEdit = 308 or xlCommand
const xlcScenarioShow = 309 or xlCommand
const xlcScenarioShowNext = 310 or xlCommand
const xlcScenarioSummary = 311 or xlCommand
const xlcPivotTableWizard = 312 or xlCommand
const xlcPivotFieldProperties = 313 or xlCommand
const xlcPivotField = 314 or xlCommand
const xlcPivotItem = 315 or xlCommand
const xlcPivotAddFields = 316 or xlCommand
const xlcOptionsCalculation = 318 or xlCommand
const xlcOptionsEdit = 319 or xlCommand
const xlcOptionsView = 320 or xlCommand
const xlcAddinManager = 321 or xlCommand
const xlcMenuEditor = 322 or xlCommand
const xlcAttachToolbars = 323 or xlCommand
const xlcVbaactivate = 324 or xlCommand
const xlcOptionsChart = 325 or xlCommand
const xlcVbaInsertFile = 328 or xlCommand
const xlcVbaProcedureDefinition = 330 or xlCommand
const xlcRoutingSlip = 336 or xlCommand
const xlcRouteDocument = 338 or xlCommand
const xlcMailLogon = 339 or xlCommand
const xlcInsertPicture = 342 or xlCommand
const xlcEditTool = 343 or xlCommand
const xlcGalleryDoughnut = 344 or xlCommand
const xlcChartTrend = 350 or xlCommand
const xlcPivotItemProperties = 352 or xlCommand
const xlcWorkbookInsert = 354 or xlCommand
const xlcOptionsTransition = 355 or xlCommand
const xlcOptionsGeneral = 356 or xlCommand
const xlcFilterAdvanced = 370 or xlCommand
const xlcMailAddMailer = 373 or xlCommand
const xlcMailDeleteMailer = 374 or xlCommand
const xlcMailReply = 375 or xlCommand
const xlcMailReplyAll = 376 or xlCommand
const xlcMailForward = 377 or xlCommand
const xlcMailNextLetter = 378 or xlCommand
const xlcDataLabel = 379 or xlCommand
const xlcInsertTitle = 380 or xlCommand
const xlcFontProperties = 381 or xlCommand
const xlcMacroOptions = 382 or xlCommand
const xlcWorkbookHide = 383 or xlCommand
const xlcWorkbookUnhide = 384 or xlCommand
const xlcWorkbookDelete = 385 or xlCommand
const xlcWorkbookName = 386 or xlCommand
const xlcGalleryCustom = 388 or xlCommand
const xlcAddChartAutoformat = 390 or xlCommand
const xlcDeleteChartAutoformat = 391 or xlCommand
const xlcChartAddData = 392 or xlCommand
const xlcAutoOutline = 393 or xlCommand
const xlcTabOrder = 394 or xlCommand
const xlcShowDialog = 395 or xlCommand
const xlcSelectAll = 396 or xlCommand
const xlcUngroupSheets = 397 or xlCommand
const xlcSubtotalCreate = 398 or xlCommand
const xlcSubtotalRemove = 399 or xlCommand
const xlcRenameObject = 400 or xlCommand
const xlcWorkbookScroll = 412 or xlCommand
const xlcWorkbookNext = 413 or xlCommand
const xlcWorkbookPrev = 414 or xlCommand
const xlcWorkbookTabSplit = 415 or xlCommand
const xlcFullScreen = 416 or xlCommand
const xlcWorkbookProtect = 417 or xlCommand
const xlcScrollbarProperties = 420 or xlCommand
const xlcPivotShowPages = 421 or xlCommand
const xlcTextToColumns = 422 or xlCommand
const xlcFormatCharttype = 423 or xlCommand
const xlcLinkFormat = 424 or xlCommand
const xlcTracerDisplay = 425 or xlCommand
const xlcTracerNavigate = 430 or xlCommand
const xlcTracerClear = 431 or xlCommand
const xlcTracerError = 432 or xlCommand
const xlcPivotFieldGroup = 433 or xlCommand
const xlcPivotFieldUngroup = 434 or xlCommand
const xlcCheckboxProperties = 435 or xlCommand
const xlcLabelProperties = 436 or xlCommand
const xlcListboxProperties = 437 or xlCommand
const xlcEditboxProperties = 438 or xlCommand
const xlcPivotRefresh = 439 or xlCommand
const xlcLinkCombo = 440 or xlCommand
const xlcOpenText = 441 or xlCommand
const xlcHideDialog = 442 or xlCommand
const xlcSetDialogFocus = 443 or xlCommand
const xlcEnableObject = 444 or xlCommand
const xlcPushbuttonProperties = 445 or xlCommand
const xlcSetDialogDefault = 446 or xlCommand
const xlcFilter = 447 or xlCommand
const xlcFilterShowAll = 448 or xlCommand
const xlcClearOutline = 449 or xlCommand
const xlcFunctionWizard = 450 or xlCommand
const xlcAddListItem = 451 or xlCommand
const xlcSetListItem = 452 or xlCommand
const xlcRemoveListItem = 453 or xlCommand
const xlcSelectListItem = 454 or xlCommand
const xlcSetControlValue = 455 or xlCommand
const xlcSaveCopyAs = 456 or xlCommand
const xlcOptionsListsAdd = 458 or xlCommand
const xlcOptionsListsDelete = 459 or xlCommand
const xlcSeriesAxes = 460 or xlCommand
const xlcSeriesX = 461 or xlCommand
const xlcSeriesY = 462 or xlCommand
const xlcErrorbarX = 463 or xlCommand
const xlcErrorbarY = 464 or xlCommand
const xlcFormatChart = 465 or xlCommand
const xlcSeriesOrder = 466 or xlCommand
const xlcMailLogoff = 467 or xlCommand
const xlcClearRoutingSlip = 468 or xlCommand
const xlcAppActivateMicrosoft = 469 or xlCommand
const xlcMailEditMailer = 470 or xlCommand
const xlcOnSheet = 471 or xlCommand
const xlcStandardWidth = 472 or xlCommand
const xlcScenarioMerge = 473 or xlCommand
const xlcSummaryInfo = 474 or xlCommand
const xlcFindFile = 475 or xlCommand
const xlcActiveCellFont = 476 or xlCommand
const xlcEnableTipwizard = 477 or xlCommand
const xlcVbaMakeAddin = 478 or xlCommand
const xlcInsertdatatable = 480 or xlCommand
const xlcWorkgroupOptions = 481 or xlCommand
const xlcMailSendMailer = 482 or xlCommand
const xlcAutocorrect = 485 or xlCommand
const xlcPostDocument = 489 or xlCommand
const xlcPicklist = 491 or xlCommand
const xlcViewShow = 493 or xlCommand
const xlcViewDefine = 494 or xlCommand
const xlcViewDelete = 495 or xlCommand
const xlcSheetBackground = 509 or xlCommand
const xlcInsertMapObject = 510 or xlCommand
const xlcOptionsMenono = 511 or xlCommand
const xlcNormal = 518 or xlCommand
const xlcLayout = 519 or xlCommand
const xlcRmPrintArea = 520 or xlCommand
const xlcClearPrintArea = 521 or xlCommand
const xlcAddPrintArea = 522 or xlCommand
const xlcMoveBrk = 523 or xlCommand
const xlcHidecurrNote = 545 or xlCommand
const xlcHideallNotes = 546 or xlCommand
const xlcDeleteNote = 547 or xlCommand
const xlcTraverseNotes = 548 or xlCommand
const xlcActivateNotes = 549 or xlCommand
const xlcProtectRevisions = 620 or xlCommand
const xlcUnprotectRevisions = 621 or xlCommand
const xlcOptionsMe = 647 or xlCommand
const xlcWebPublish = 653 or xlCommand
const xlcNewwebquery = 667 or xlCommand
const xlcPivotTableChart = 673 or xlCommand
const xlcOptionsSave = 753 or xlCommand
const xlcOptionsSpell = 755 or xlCommand
const xlcHideallInkannots = 808 or xlCommand

'#if defined(__FB_WIN32__) or defined(__FB_CYGWIN__)
	
'#endif
